=== debian/changelog ===
libmongoc (1.9.5+dfsg-1) unstable; urgency=low

  * New upstream release

 -- A. Jesse Jiryu Davis <jesse@mongodb.com>  Mon, 30 Apr 2018 22:44:57 -0400

libmongoc (1.9.4+dfsg-2) unstable; urgency=low

  * Update libbson build dependency

 -- A. Jesse Jiryu Davis <jesse@mongodb.com>  Tue, 10 Apr 2018 16:31:45 -0400

libmongoc (1.9.4+dfsg-1) unstable; urgency=low

  * New upstream release
  * Update to Standards-Version 4.1.4 (no changes)

 -- A. Jesse Jiryu Davis <jesse@mongodb.com>  Tue, 10 Apr 2018 08:14:08 -0400

libmongoc (1.9.3+dfsg-2) unstable; urgency=low

  * Update libbson build dependency (Closes: #892101)

 -- A. Jesse Jiryu Davis <jesse@mongodb.com>  Mon, 05 Mar 2018 12:35:34 -0500

libmongoc (1.9.3+dfsg-1) unstable; urgency=low

  * New upstream release

 -- A. Jesse Jiryu Davis <jesse@mongodb.com>  Fri, 02 Mar 2018 11:42:26 -0500
